/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.modelflattening.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.microsoft.rest.serializer.JsonFlatten;

/**
 * Additional parameters for the putSimpleProductWithGrouping operation.
 */
@JsonFlatten
public class FlattenParameterGroup {
    /**
     * Product name with value 'groupproduct'.
     */
    @JsonProperty(value = "", required = true)
    private String name;

    /**
     * Unique identifier representing a specific product for a given latitude
     * &amp; longitude. For example, uberX in San Francisco will have a
     * different product_id than uberX in Los Angeles.
     */
    @JsonProperty(value = "", required = true)
    private String baseProductId;

    /**
     * Description of product.
     */
    @JsonProperty(value = "")
    private String baseProductDescription;

    /**
     * Display name of product.
     */
    @JsonProperty(value = "", required = true)
    private String maxProductDisplayName;

    /**
     * URL value.
     */
    @JsonProperty(value = "")
    private String odatavalue;

    /**
     * Get the name value.
     *
     * @return the name value
     */
    public String getName() {
        return this.name;
    }

    /**
     * Set the name value.
     *
     * @param name the name value to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the baseProductId value.
     *
     * @return the baseProductId value
     */
    public String getBaseProductId() {
        return this.baseProductId;
    }

    /**
     * Set the baseProductId value.
     *
     * @param baseProductId the baseProductId value to set
     */
    public void setBaseProductId(String baseProductId) {
        this.baseProductId = baseProductId;
    }

    /**
     * Get the baseProductDescription value.
     *
     * @return the baseProductDescription value
     */
    public String getBaseProductDescription() {
        return this.baseProductDescription;
    }

    /**
     * Set the baseProductDescription value.
     *
     * @param baseProductDescription the baseProductDescription value to set
     */
    public void setBaseProductDescription(String baseProductDescription) {
        this.baseProductDescription = baseProductDescription;
    }

    /**
     * Get the maxProductDisplayName value.
     *
     * @return the maxProductDisplayName value
     */
    public String getMaxProductDisplayName() {
        return this.maxProductDisplayName;
    }

    /**
     * Set the maxProductDisplayName value.
     *
     * @param maxProductDisplayName the maxProductDisplayName value to set
     */
    public void setMaxProductDisplayName(String maxProductDisplayName) {
        this.maxProductDisplayName = maxProductDisplayName;
    }

    /**
     * Get the odatavalue value.
     *
     * @return the odatavalue value
     */
    public String getOdatavalue() {
        return this.odatavalue;
    }

    /**
     * Set the odatavalue value.
     *
     * @param odatavalue the odatavalue value to set
     */
    public void setOdatavalue(String odatavalue) {
        this.odatavalue = odatavalue;
    }

}
