# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.service_client import ServiceClient
from msrest import Configuration, Serializer, Deserializer
from .version import VERSION
from .operations.byte import Byte
from . import models


class AutoRestSwaggerBATByteServiceConfiguration(Configuration):
    """Configuration for AutoRestSwaggerBATByteService
    Note that all parameters used to create this instance are saved as instance
    attributes.

    :param str base_url: Service URL
    :param str filepath: Existing config
    """

    def __init__(
            self, base_url=None, filepath=None):

        if not base_url:
            base_url = 'http://localhost'

        super(AutoRestSwaggerBATByteServiceConfiguration, self).__init__(base_url, filepath)

        self.add_user_agent('autorestswaggerbatbyteservice/{}'.format(VERSION))


class AutoRestSwaggerBATByteService(object):
    """Test Infrastructure for AutoRest Swagger BAT

    :param config: Configuration for client.
    :type config: AutoRestSwaggerBATByteServiceConfiguration

    :ivar byte: Byte operations
    :vartype byte: .operations.Byte
    """

    def __init__(self, config):

        self._client = ServiceClient(None, config)

        client_models = {k: v for k, v in models.__dict__.items() if isinstance(v, type)}
        self._serialize = Serializer()
        self._deserialize = Deserializer(client_models)

        self.config = config
        self.byte = Byte(
            self._client, self.config, self._serialize, self._deserialize)
